searchNodes=[{"doc":"Complex is a library for types and mathematical functions for complex numbers.Each complex number is represented as a structure holding the real and imaginary part. There are functions for creation and manipulation of them. Unfortunately since there is no operator overloading in Elixir the math functions (add, subtract, etc.) are implemented as add/2, sub/2, etc.Examplesiex&gt; Complex.new(3, 4) %Complex{im: 4, re: 3} iex&gt; Complex.imag() %Complex{im: 1.0, re: 0.0}","ref":"Complex.html","title":"Complex","type":"module"},{"doc":"Returns the magnitude (length) of the provided complex number.See alsonew/2, phase/1Examplesiex&gt; Complex.abs( Complex.fromPolar(1, :math.pi/2) ) 1.0","ref":"Complex.html#abs/1","title":"Complex.abs/1","type":"function"},{"doc":"Returns the square of the magnitude of the provided complex number.The square of the magnitude is faster to compute---no square roots!See alsonew/2, abs/1Examplesiex&gt; Complex.abs_squared( Complex.fromPolar(1, :math.pi/2) ) 1.0 iex&gt; Complex.abs_squared( Complex.fromPolar(2, :math.pi/2) ) 4.0","ref":"Complex.html#abs_squared/1","title":"Complex.abs_squared/1","type":"function"},{"doc":"Returns a new complex that is the inverse cosine (i.e., arccosine) of the provided parameter.See alsocos/1Examplesiex&gt; Complex.acos( Complex.fromPolar(2,:math.pi) ) %Complex{im: 1.3169578969248164, re: -3.141592653589793} iex&gt; Complex.cos( Complex.acos(Complex.new(2,3)) ) %Complex{im: 3.0, re: 2.0000000000000004}","ref":"Complex.html#acos/1","title":"Complex.acos/1","type":"function"},{"doc":"Returns a new complex that is the inverse hyperbolic cosine (i.e., arccosh) of the provided parameter.See alsocosh/1Examplesiex&gt; Complex.acosh( Complex.fromPolar(2,:math.pi) ) %Complex{im: -3.141592653589793, re: -1.3169578969248164} iex&gt; Complex.cosh( Complex.acosh(Complex.new(2,3)) ) %Complex{im: 3.0, re: 2.0}","ref":"Complex.html#acosh/1","title":"Complex.acosh/1","type":"function"},{"doc":"Returns a new complex that is the inverse cotangent (i.e., arccotangent) of the provided parameter.See alsocot/1Examplesiex&gt; Complex.acot( Complex.fromPolar(2,:math.pi) ) %Complex{im: -9.71445146547012e-17, re: -0.46364760900080615} iex&gt; Complex.cot( Complex.acot(Complex.new(2,3)) ) %Complex{im: 2.9999999999999996, re: 1.9999999999999991}","ref":"Complex.html#acot/1","title":"Complex.acot/1","type":"function"},{"doc":"Returns a new complex that is the inverse hyperbolic cotangent (i.e., arccoth) of the provided parameter.See alsocoth/1Examplesiex&gt; Complex.acoth( Complex.fromPolar(2,:math.pi) ) %Complex{im: -8.164311994315688e-17, re: -0.5493061443340548} iex&gt; Complex.coth( Complex.acoth(Complex.new(2,3)) ) %Complex{im: 2.999999999999998, re: 2.000000000000001}","ref":"Complex.html#acoth/1","title":"Complex.acoth/1","type":"function"},{"doc":"Returns a new complex that is the inverse cosecant (i.e., arccosecant) of the provided parameter.See alsosec/1Examplesiex&gt; Complex.acsc( Complex.fromPolar(2,:math.pi) ) %Complex{im: 0.0, re: -0.5235987755982988} iex&gt; Complex.csc( Complex.acsc(Complex.new(2,3)) ) %Complex{im: 2.9999999999999996, re: 1.9999999999999993}","ref":"Complex.html#acsc/1","title":"Complex.acsc/1","type":"function"},{"doc":"Returns a new complex that is the inverse hyperbolic cosecant (i.e., arccsch) of the provided parameter.See alsocsch/1Examplesiex&gt; Complex.acsch( Complex.fromPolar(2,:math.pi) ) %Complex{im: -5.4767869826420256e-17, re: -0.48121182505960336} iex&gt; Complex.csch( Complex.acsch(Complex.new(2,3)) ) %Complex{im: 3.0000000000000018, re: 1.9999999999999982}","ref":"Complex.html#acsch/1","title":"Complex.acsch/1","type":"function"},{"doc":"Returns a new complex that is the sum of the provided complex numbers. Also supports a mix of complex and number. #### See also div/2, mult/2, sub/2 #### Examples iex&gt; Complex.add( Complex.fromPolar(1, :math.pi/2), Complex.fromPolar(1, :math.pi/2) ) %Complex{im: 2.0, re: 1.2246467991473532e-16} iex&gt; Complex.add( Complex.new(4, 4), 1 ) %Complex{im: 4, re: 5} iex&gt; Complex.add( 2, Complex.new(4, 3) ) %Complex{im: 3, re: 6} iex&gt; Complex.add( 2, 3 ) %Complex{im: 0, re: 5}","ref":"Complex.html#add/2","title":"Complex.add/2","type":"function"},{"doc":"Returns a new complex that is the inverse secant (i.e., arcsecant) of the provided parameter.See alsosec/1Examplesiex&gt; Complex.asec( Complex.fromPolar(2,:math.pi) ) %Complex{im: 0.0, re: 2.0943951023931957} iex&gt; Complex.sec( Complex.asec(Complex.new(2,3)) ) %Complex{im: 2.9999999999999987, re: 1.9999999999999987}","ref":"Complex.html#asec/1","title":"Complex.asec/1","type":"function"},{"doc":"Returns a new complex that is the inverse hyperbolic secant (i.e., arcsech) of the provided parameter.See alsosech/1Examplesiex&gt; Complex.asech( Complex.fromPolar(2,:math.pi) ) %Complex{im: -2.0943951023931953, re: 0.0} iex&gt; Complex.sech( Complex.asech(Complex.new(2,3)) ) %Complex{im: 2.999999999999999, re: 2.0}","ref":"Complex.html#asech/1","title":"Complex.asech/1","type":"function"},{"doc":"Returns a new complex that is the inverse sine (i.e., arcsine) of the provided parameter.See alsosin/1Examplesiex&gt; Complex.asin( Complex.fromPolar(2,:math.pi) ) %Complex{im: 1.3169578969248164, re: -1.5707963267948963} iex&gt; Complex.sin( Complex.asin(Complex.new(2,3)) ) %Complex{im: 3.000000000000001, re: 1.9999999999999991}","ref":"Complex.html#asin/1","title":"Complex.asin/1","type":"function"},{"doc":"Returns a new complex that is the inverse hyperbolic sine (i.e., arcsinh) of the provided parameter.See alsosinh/1Examplesiex&gt; Complex.asinh( Complex.fromPolar(2,:math.pi) ) %Complex{im: 1.0953573965284052e-16, re: -1.4436354751788099} iex&gt; Complex.sinh( Complex.asinh(Complex.new(2,3)) ) %Complex{im: 3.0, re: 2.000000000000001}","ref":"Complex.html#asinh/1","title":"Complex.asinh/1","type":"function"},{"doc":"Returns a new complex that is the inverse tangent (i.e., arctangent) of the provided parameter.See alsotan/1Examplesiex&gt; Complex.atan( Complex.fromPolar(2,:math.pi) ) %Complex{im: 0.0, re: -1.1071487177940904} iex&gt; Complex.tan( Complex.atan(Complex.new(2,3)) ) %Complex{im: 3.0, re: 2.0}","ref":"Complex.html#atan/1","title":"Complex.atan/1","type":"function"},{"doc":"Returns a new complex that is the inverse hyperbolic tangent (i.e., arctanh) of the provided parameter.See alsotanh/1Examplesiex&gt; Complex.atanh( Complex.fromPolar(2,:math.pi) ) %Complex{im: 1.5707963267948966, re: -0.5493061443340549} iex&gt; Complex.tanh( Complex.atanh(Complex.new(2,3)) ) %Complex{im: 2.999999999999999, re: 1.9999999999999987}","ref":"Complex.html#atanh/1","title":"Complex.atanh/1","type":"function"},{"doc":"Returns a new complex that is the complex conjugate of the provided complex number.See alsoabs/2, phase/1Examplesiex&gt; Complex.conjugate( Complex.new(1,2) ) %Complex{im: -2, re: 1}","ref":"Complex.html#conjugate/1","title":"Complex.conjugate/1","type":"function"},{"doc":"Returns a new complex that is the cosine of the provided parameter.See alsosin/1, tan/1Examplesiex&gt; Complex.cos( Complex.fromPolar(2,:math.pi) ) %Complex{im: 2.2271363664699914e-16, re: -0.4161468365471424}","ref":"Complex.html#cos/1","title":"Complex.cos/1","type":"function"},{"doc":"Returns a new complex that is the hyperbolic cosine of the provided parameter.See alsosinh/1, tanh/1Examplesiex&gt; Complex.cosh( Complex.fromPolar(2,:math.pi) ) %Complex{im: -8.883245978848233e-16, re: 3.7621956910836314}","ref":"Complex.html#cosh/1","title":"Complex.cosh/1","type":"function"},{"doc":"Returns a new complex that is the cotangent of the provided parameter.See alsosin/1, cos/1, tan/1Examplesiex&gt; Complex.cot( Complex.fromPolar(2,:math.pi) ) %Complex{im: -2.9622992129532336e-16, re: 0.45765755436028577}","ref":"Complex.html#cot/1","title":"Complex.cot/1","type":"function"},{"doc":"Returns a new complex that is the hyperbolic cotangent of the provided parameter.See alsosinh/1, cosh/1, tanh/1Examplesiex&gt; Complex.coth( Complex.fromPolar(2,:math.pi) ) %Complex{im: -1.8619978115303632e-17, re: -1.037314720727548}","ref":"Complex.html#coth/1","title":"Complex.coth/1","type":"function"},{"doc":"Returns a new complex that is the cosecant of the provided parameter.See alsosec/1, sin/1, cos/1, tan/1Examplesiex&gt; Complex.csc( Complex.fromPolar(2,:math.pi) ) %Complex{im: 1.2327514463765779e-16, re: -1.0997501702946164}","ref":"Complex.html#csc/1","title":"Complex.csc/1","type":"function"},{"doc":"Returns a new complex that is the hyperbolic cosecant of the provided parameter.See alsosinh/1, cosh/1, tanh/1Examplesiex&gt; Complex.csch( Complex.fromPolar(2,:math.pi) ) %Complex{im: -7.00520014334671e-17, re: -0.2757205647717832}","ref":"Complex.html#csch/1","title":"Complex.csch/1","type":"function"},{"doc":"Returns a new complex that is the ratio (division) of the provided complex numbers.See alsoadd/2, mult/2, sub/2Examplesiex&gt; Complex.div( Complex.fromPolar(1, :math.pi/2), Complex.fromPolar(1, :math.pi/2) ) %Complex{im: 0.0, re: 1.0}","ref":"Complex.html#div/2","title":"Complex.div/2","type":"function"},{"doc":"Returns a new complex that is the complex exponential of the provided complex number. That is, e raised to the power z.See alsoln/1Examplesiex&gt; Complex.exp( Complex.fromPolar(2,:math.pi) ) %Complex{im: 3.3147584285483636e-17, re: 0.1353352832366127}","ref":"Complex.html#exp/1","title":"Complex.exp/1","type":"function"},{"doc":"Returns a new complex number described by the supplied polar coordinates.That is, the complex (real and imaginary) will have radius (magnitude) r and angle (phase) phi.See alsonew/2imag/0Examplesiex&gt; Complex.fromPolar(1, :math.pi/2) %Complex{im: 1.0, re: 6.123233995736766e-17}","ref":"Complex.html#fromPolar/2","title":"Complex.fromPolar/2","type":"function"},{"doc":"Returns the polar coordinates of the supplied complex. That is, the returned tuple {r,phi} is the magnitude and phase (in radians) of z.See alsofromPolar/2Examplesiex&gt; Complex.getPolar( Complex.fromPolar(1,:math.pi/2) ) {1.0, 1.5707963267948966}","ref":"Complex.html#getPolar/1","title":"Complex.getPolar/1","type":"function"},{"doc":"Returns a new complex representing the pure imaginary number sqrt(-1).See alsonew/2fromPolar/2Examplesiex&gt; Complex.imag() %Complex{im: 1.0, re: 0.0}","ref":"Complex.html#imag/0","title":"Complex.imag/0","type":"function"},{"doc":"Returns a new complex that is the complex natural log of the provided complex number. That is, log base e of z.See alsoexp/1Examplesiex&gt; Complex.ln( Complex.fromPolar(2,:math.pi) ) %Complex{im: 3.141592653589793, re: 0.6931471805599453}","ref":"Complex.html#ln/1","title":"Complex.ln/1","type":"function"},{"doc":"Returns a new complex that is the complex log base 10 of the provided complex number.See alsoln/1Examplesiex&gt; Complex.log10( Complex.fromPolar(2,:math.pi) ) %Complex{im: 1.3643763538418412, re: 0.30102999566398114}","ref":"Complex.html#log10/1","title":"Complex.log10/1","type":"function"},{"doc":"Returns a new complex that is the complex log base 2 of the provided complex number.See alsoln/1, log10/1Examplesiex&gt; Complex.log2( Complex.fromPolar(2,:math.pi) ) %Complex{im: 4.532360141827194, re: 1.0}","ref":"Complex.html#log2/1","title":"Complex.log2/1","type":"function"},{"doc":"Returns a new complex that is the product of the provided complex numbers. Also supports a mix of complex and number.See alsoadd/2, div/2, sub/2Examplesiex&gt; Complex.mult( Complex.new(1,2), Complex.new(3,4) ) %Complex{im: 10, re: -5} iex&gt; Complex.mult( Complex.imag(), Complex.imag() ) %Complex{im: 0.0, re: -1.0} iex&gt; Complex.mult(Complex.new(1, 2), 3 ) %Complex{im: 6, re: 3} iex&gt; Complex.mult( 3, Complex.new(1, 2) ) %Complex{im: 6, re: 3}","ref":"Complex.html#mult/2","title":"Complex.mult/2","type":"function"},{"doc":"Returns a new complex that is the &quot;negation&quot; of the provided parameter. That is, the real and imaginary parts are negated.See alsoneq/2, imag/0Examplesiex&gt; Complex.neg( Complex.new(3,5) ) %Complex{im: -5, re: -3}","ref":"Complex.html#neg/1","title":"Complex.neg/1","type":"function"},{"doc":"Returns a new complex with specified real and imaginary components. The imaginary part defaults to zero so a &quot;real&quot; number can be created with new/1See alsoimag/0fromPolar/2Examplesiex&gt; Complex.new(3, 4) %Complex{im: 4, re: 3} iex&gt; Complex.new(2) %Complex{im: 0, re: 2}","ref":"Complex.html#new/2","title":"Complex.new/2","type":"function"},{"doc":"Parses a complex number from a string. The values of the real and imaginary parts must be represented by a float, including decimal and at least one trailing digit (e.g. 1.2, 0.4).See alsonew/2Examplesiex&gt; Complex.parse(&quot;1.1+2.2i&quot;) %Complex{im: 2.2, re: 1.1}","ref":"Complex.html#parse/1","title":"Complex.parse/1","type":"function"},{"doc":"Returns the phase angle of the supplied complex, in radians.See alsonew/2fromPolar/2Examplesiex&gt; Complex.phase( Complex.fromPolar(1,:math.pi/2) ) 1.5707963267948966","ref":"Complex.html#phase/1","title":"Complex.phase/1","type":"function"},{"doc":"Returns a new complex that is the provided parameter a raised to the complex power b.See alsoln/1, log10/1Examplesiex&gt; Complex.pow( Complex.fromPolar(2,:math.pi), Complex.imag() ) %Complex{im: 0.027612020368333014, re: 0.03324182700885666}","ref":"Complex.html#pow/2","title":"Complex.pow/2","type":"function"},{"doc":"Returns a new complex that is the secant of the provided parameter.See alsosin/1, cos/1, tan/1Examplesiex&gt; Complex.sec( Complex.fromPolar(2,:math.pi) ) %Complex{im: -1.2860374461837126e-15, re: -2.402997961722381}","ref":"Complex.html#sec/1","title":"Complex.sec/1","type":"function"},{"doc":"Returns a new complex that is the hyperbolic secant of the provided parameter.See alsosinh/1, cosh/1, tanh/1Examplesiex&gt; Complex.sech( Complex.fromPolar(2,:math.pi) ) %Complex{im: 6.27608655779184e-17, re: 0.2658022288340797}","ref":"Complex.html#sech/1","title":"Complex.sech/1","type":"function"},{"doc":"Returns a new complex that is the sine of the provided parameter.See alsocos/1, tan/1Examplesiex&gt; Complex.sin( Complex.fromPolar(2,:math.pi) ) %Complex{im: -1.0192657827055095e-16, re: -0.9092974268256817}","ref":"Complex.html#sin/1","title":"Complex.sin/1","type":"function"},{"doc":"Returns a new complex that is the hyperbolic sine of the provided parameter.See alsocosh/1, tanh/1Examplesiex&gt; Complex.sinh( Complex.fromPolar(2,:math.pi) ) %Complex{im: 9.214721821703068e-16, re: -3.626860407847019}","ref":"Complex.html#sinh/1","title":"Complex.sinh/1","type":"function"},{"doc":"Returns a new complex that is the complex square root of the provided complex number.See alsoabs/2, phase/1Examplesiex&gt; Complex.sqrt( Complex.fromPolar(2,:math.pi) ) %Complex{im: 1.4142135623730951, re: 8.659560562354933e-17}","ref":"Complex.html#sqrt/1","title":"Complex.sqrt/1","type":"function"},{"doc":"Returns a new complex that is the square of the provided complex number.See alsomult/2Examplesiex&gt; Complex.square( Complex.new(2.0, 0.0) ) %Complex{im: 0.0, re: 4.0} iex&gt; Complex.square( Complex.imag() ) %Complex{im: 0.0, re: -1.0}","ref":"Complex.html#square/1","title":"Complex.square/1","type":"function"},{"doc":"Returns a new complex that is the difference of the provided complex numbers. Also supports a mix of complex and number. #### See also add/2, div/2, mult/2 #### Examples iex&gt; Complex.sub( Complex.new(1,2), Complex.new(3,4) ) %Complex{im: -2, re: 0-2} iex&gt; Complex.sub( Complex.new(1, 2), 3 ) %Complex{im: 2, re: -2} iex&gt; Complex.sub( 10, Complex.new(1, 2) ) %Complex{im: -2, re: 9}","ref":"Complex.html#sub/2","title":"Complex.sub/2","type":"function"},{"doc":"Returns a new complex that is the tangent of the provided parameter.See alsosin/1, cos/1Examplesiex&gt; Complex.tan( Complex.fromPolar(2,:math.pi) ) %Complex{im: 1.4143199004457917e-15, re: 2.185039863261519}","ref":"Complex.html#tan/1","title":"Complex.tan/1","type":"function"},{"doc":"Returns a new complex that is the hyperbolic tangent of the provided parameter.See alsosinh/1, cosh/1Examplesiex&gt; Complex.tanh( Complex.fromPolar(2,:math.pi) ) %Complex{im: 1.7304461302709572e-17, re: -0.964027580075817}","ref":"Complex.html#tanh/1","title":"Complex.tanh/1","type":"function"},{"doc":"General type for complex numbers","ref":"Complex.html#t:complex/0","title":"Complex.complex/0","type":"type"}]